GNU bug report logs - #48011
27.2; Emacs freezes in modula 2 mode when entering a :

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Dan Čermák <dan.cermak@HIDDEN>; Keywords: patch; dated Sun, 25 Apr 2021 08:28:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Added tag(s) patch. Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Removed tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 48011 <at> debbugs.gnu.org:


Received: (at 48011) by debbugs.gnu.org; 26 Apr 2021 12:19:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 26 08:19:22 2021
Received: from localhost ([127.0.0.1]:44821 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lb0Cw-0000nV-IT
	for submit <at> debbugs.gnu.org; Mon, 26 Apr 2021 08:19:22 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38020)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lb0Cv-0000nI-En
 for 48011 <at> debbugs.gnu.org; Mon, 26 Apr 2021 08:19:21 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54894)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lb0Cp-00089w-Aj; Mon, 26 Apr 2021 08:19:15 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4512
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lb0Cm-0004uJ-E7; Mon, 26 Apr 2021 08:19:15 -0400
Date: Mon, 26 Apr 2021 15:18:53 +0300
Message-Id: <83mttljl1u.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Dan =?utf-8?B?xIxlcm3DoWs=?= <dan.cermak@HIDDEN>
In-Reply-To: <87bla1s4zo.fsf@HIDDEN> (message from Dan
 =?utf-8?B?xIxlcm3DoWs=?= on Mon, 26 Apr 2021 12:40:59 +0200)
Subject: Re: bug#48011: 27.2; Emacs freezes in modula 2 mode when entering a :
References: <877dkqdclu.fsf@HIDDEN> <83v98alp0a.fsf@HIDDEN>
 <677a04021bcb852ed91a@HIDDEN> <87bla1s4zo.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48011
Cc: 48011 <at> debbugs.gnu.org, gregory@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Dan Čermák <dan.cermak@HIDDEN>
> Cc: 48011 <at> debbugs.gnu.org
> Date: Mon, 26 Apr 2021 12:40:59 +0200
> 
> Gregory Heytings <gregory@HIDDEN> writes:
> 
> > And here is the patch.
> 
> I can confirm that the patch solves the problem for me.
> 
> Can it be pushed to the Emacs repository?

We are waiting for Gregory's legal paperwork to come though, and will
install then.

Thanks for testing the patch.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#48011; Package emacs. Full text available.

Message received at 48011 <at> debbugs.gnu.org:


Received: (at 48011) by debbugs.gnu.org; 26 Apr 2021 10:41:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 26 06:41:15 2021
Received: from localhost ([127.0.0.1]:44748 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1layfz-0004jU-1l
	for submit <at> debbugs.gnu.org; Mon, 26 Apr 2021 06:41:15 -0400
Received: from cgc-instruments.com ([83.169.1.125]:39174)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dan.cermak@HIDDEN>) id 1layfw-0004jJ-AL
 for 48011 <at> debbugs.gnu.org; Mon, 26 Apr 2021 06:41:13 -0400
Received: from localhost (ip4d17fc76.dynamic.kabel-deutschland.de
 [77.23.252.118])
 by cgc-instruments.com (Postfix) with ESMTPSA id 392E3A09EF;
 Mon, 26 Apr 2021 12:41:10 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cgc-instruments.com;
 s=default; t=1619433670;
 bh=QrQ9afHzXu8r4SucJiMz2TG6tqyEtyJaIrDNwkBKktE=; l=1220;
 h=From:To:Subject;
 b=DqbmnnoE8sy/uzn0ALC+5+c0ZXNREG+04qRkIpCCxZOFKBMy07zTXenyOUwsV2U1m
 tqNX/n15it57QI/yOdQIePApkJm8yMe6R6QLb6sfMibPLqV+B4PSf+4xkk5jRauT1i
 p/j0ZHm0vFQboVvsewWTdWB8KCb8bE71nEnqWELY=
Authentication-Results: cgc-instruments.com;
 spf=pass (sender IP is 77.23.252.118)
 smtp.mailfrom=dan.cermak@HIDDEN smtp.helo=localhost
Received-SPF: pass (cgc-instruments.com: connection is authenticated)
From: Dan =?utf-8?B?xIxlcm3DoWs=?= <dan.cermak@HIDDEN>
To: Gregory Heytings <gregory@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#48011: 27.2; Emacs freezes in modula 2 mode when entering a :
In-Reply-To: <677a04021bcb852ed91a@HIDDEN>
References: <877dkqdclu.fsf@HIDDEN> <83v98alp0a.fsf@HIDDEN>
 <677a04021bcb852ed91a@HIDDEN>
Date: Mon, 26 Apr 2021 12:40:59 +0200
Message-ID: <87bla1s4zo.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48011
Cc: 48011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Gregory Heytings <gregory@HIDDEN> writes:

> And here is the patch.

I can confirm that the patch solves the problem for me.

Can it be pushed to the Emacs repository?


Cheers,

Dan

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJTBAEBCAA9FiEE/2KDnDCX6+IOiSay5jLDOAYQ0cUFAmCGmLsfHGRhbi5jZXJt
YWtAY2djLWluc3RydW1lbnRzLmNvbQAKCRDmMsM4BhDRxVefD/9/MsNKvJL43eDF
h6FgjSzRh3NcQX/2uAUfrnnrmOcutuN2+uKRSn3qVpuzWxuCxMu0eytcNhzy41B6
kmPJfCGSmJAmgbhVQgVM0k91pk1TgDCsugvvxmhemzizly6MH2mBHqb8V2vpb3nI
J5Nsqr5SM3Y5TARsx3g9tvlkRV+mEWKZI61+rYVwMoPYftx2uMrG7FUAQ4Hp9Ns8
Z3kg2OIdRfn9BwTAOjYbPMhvzIkK+U97K/i+yHvZ6/tr9HcgNdVAKSDVL7gDYSeH
UEpZw8DmHGzCVDen4SfJCMR30JL9a664zBjIFEBmM67FUnCLREvgi8LoJO/dOP9m
hpCrKz0P88zJNLJgNuO77Jo2RiPSuOhu1gjAeXF/uBtVcMnOrbJ0NE9Da4aNs9jP
rT0AGSW4eiN+96WUyRV4fREKTKExuqxmlctpiMhwsQHoHkhqxwnyAViAVSc4bYyC
XMQiqp/ZmUW+yFIcHBFGiYOOJ6VIuOKOdn80WVqSYsAswMBqUFDUKD7wSH3RBMpX
d/N8dlyTU4viow8HA3/HUMti05xEZ7yg9vtR6IxZ0+iW8h2N8OEjAHt9z1MaoP4/
ly2rFPymHpa+eYk1aF+tpAzZD8MNh/oCgFxPn7VHK5qbAAonTrNHxgA/kl0Fcyr7
crK6Eqo+wD2/oCUqba+dTxEoAVm1Xw==
=hqed
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#48011; Package emacs. Full text available.
Added tag(s) moreinfo. Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 48011 <at> debbugs.gnu.org:


Received: (at 48011) by debbugs.gnu.org; 25 Apr 2021 10:37:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 25 06:37:13 2021
Received: from localhost ([127.0.0.1]:42063 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lac8X-0004Y2-AU
	for submit <at> debbugs.gnu.org; Sun, 25 Apr 2021 06:37:13 -0400
Received: from heytings.org ([95.142.160.155]:52386)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lac8W-0004Xu-2F
 for 48011 <at> debbugs.gnu.org; Sun, 25 Apr 2021 06:37:12 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1619347031;
 bh=FtSaSnvZ9orza658ds6eAc+yoSW0zwezn7B+79jPK3c=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=VEP483Iqj6xH7ANk42nSExdwFXte0Aui5uqYxc+7b48tlVWzK6ruosvV/qtwMmGHk
 cchWYE6oSuXIl6OZzSAp7iErxqfOiW+O/K5O1ZE7XGXMyYJWUdoAXa8FbCvZrFMCFY
 LFqt8bT/b7mxVW7mWpQ85UaKhX3ggbJjvb4YsT9/NFkVxbyULtvpWJnWk2UgxMFNUY
 /jP8IPkXboEJg4kaFZdTnbj+7R0kZK2ml3Qz5Iny2zjAjPo92zGvN7mlPcNm2J3YMR
 e7gpYH7eBHSIVRXp1iSdzKPVc5bwdBQ9qA8y78q9aRf9M1wuKqLuDIRYslMJmN+QPe
 euOfKvD5faCZA==
Date: Sun, 25 Apr 2021 10:37:10 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#48011: 27.2; Emacs freezes in modula 2 mode when entering a :
In-Reply-To: <83v98alp0a.fsf@HIDDEN>
Message-ID: <677a04021bcb852ed91a@HIDDEN>
References: <877dkqdclu.fsf@HIDDEN> <83v98alp0a.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="e8QXEZag8p"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48011
Cc: =?UTF-8?Q?Dan_=C4=8Cerm=C3=A1k?= <dan.cermak@HIDDEN>,
 48011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--e8QXEZag8p
Content-Type: text/plain; format=flowed; charset=us-ascii


>
> I cannot reproduce this using the recipe in the Bugzilla report, neither 
> in Emacs 27.2 nor in the current master branch.  I see no hang.
>

The recipe isn't precise enough:

emacs -Q foo.mod
set SPC PROD SPC : SPC

Emacs hangs after the second SPC.  This bug is an old one, Emacs 24 has 
the same problem.  In fact an ever shorter recipe also works:

emacs -Q foo.mod
: SPC

>
> If C-g interrupts the hang, please set debug-on-signal non-nil, repeat 
> the recipe, press C-g, and post the Lisp backtrace here.
>

You probably meant "debug-on-quit".  Here is the backtrace:

smie-default-backward-token()
m2-smie-refine-colon()
m2-smie-backward-token()
smie-blink-matching-open()
self-insert-command(1 32)
funcall-interactively(self-insert-command 1 32)
call-interactively(self-insert-command nil nil)
command-execute(self-insert-command)

And here is the patch.
--e8QXEZag8p
Content-Type: text/x-diff; name=Fix-infloop-in-Modula-2-mode.patch
Content-Transfer-Encoding: base64
Content-ID: <677a04021b3a6f8104e5@HIDDEN>
Content-Description: 
Content-Disposition: attachment; filename=Fix-infloop-in-Modula-2-mode.patch

RnJvbSA0NjJjYTA2NTRkMmFhMmEyYjY1MDZmMmU5YTFhOWNlYjhlNjgzY2Fk
IE1vbiBTZXAgMTcgMDA6MDA6MDAgMjAwMQ0KRnJvbTogR3JlZ29yeSBIZXl0
aW5ncyA8Z3JlZ29yeUBoZXl0aW5ncy5vcmc+DQpEYXRlOiBTdW4sIDI1IEFw
ciAyMDIxIDEwOjMzOjQ4ICswMDAwDQpTdWJqZWN0OiBbUEFUQ0hdIEZpeCBp
bmZsb29wIGluIE1vZHVsYS0yIG1vZGUNCg0KKiBsaXNwL3Byb2dtb2Rlcy9t
b2R1bGEyLmVsIChtMi1zbWllLXJlZmluZS1jb2xvbik6IFN0b3AgbG9vcGlu
ZyB3aGVuDQpwb2ludCBkb2VzIG5vdCBtb3ZlIHdpdGggZm9yd2FyZC1zZXhw
IChCdWcjNDgwMTEpDQotLS0NCiBsaXNwL3Byb2dtb2Rlcy9tb2R1bGEyLmVs
IHwgNSArKysrLQ0KIDEgZmlsZSBjaGFuZ2VkLCA0IGluc2VydGlvbnMoKyks
IDEgZGVsZXRpb24oLSkNCg0KZGlmZiAtLWdpdCBhL2xpc3AvcHJvZ21vZGVz
L21vZHVsYTIuZWwgYi9saXNwL3Byb2dtb2Rlcy9tb2R1bGEyLmVsDQppbmRl
eCAyYTAzNzRhYTgxLi41NzU2ZDkxODMxIDEwMDY0NA0KLS0tIGEvbGlzcC9w
cm9nbW9kZXMvbW9kdWxhMi5lbA0KKysrIGIvbGlzcC9wcm9nbW9kZXMvbW9k
dWxhMi5lbA0KQEAgLTIwMSw3ICsyMDEsMTAgQEAgbTItc21pZS1yZWZpbmUt
Y29sb24NCiAgICAgICAgICAoKHplcm9wIChsZW5ndGggdG9rKSkNCiAgICAg
ICAgICAgKGxldCAoKGZvcndhcmQtc2V4cC1mdW5jdGlvbiBuaWwpKQ0KICAg
ICAgICAgICAgIChjb25kaXRpb24tY2FzZSBuaWwNCi0gICAgICAgICAgICAg
ICAgKGZvcndhcmQtc2V4cCAtMSkNCisgICAgICAgICAgICAgICAgKGxldCAo
KHAgKHBvaW50KSkpDQorICAgICAgICAgICAgICAgICAgKGZvcndhcmQtc2V4
cCAtMSkNCisgICAgICAgICAgICAgICAgICAoaWYgKD0gcCAocG9pbnQpKQ0K
KyAgICAgICAgICAgICAgICAgICAgICAoc2V0cSByZXMgIjoiKSkpDQogICAg
ICAgICAgICAgICAoc2Nhbi1lcnJvciAoc2V0cSByZXMgIjoiKSkpKSkNCiAg
ICAgICAgICAoKG1lbWJlciB0b2sgJygifCIgIk9GIiAiLi4iKSkgKHNldHEg
cmVzICI6LWNhc2UiKSkNCiAgICAgICAgICAoKG1lbWJlciB0b2sgJygiOiIg
IkVORCIgIjsiICJCRUdJTiIgIlZBUiIgIlJFQ09SRCIgIlBST0NFRFVSRSIp
KQ0KLS0gDQoyLjMwLjINCg0K

--e8QXEZag8p--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#48011; Package emacs. Full text available.

Message received at 48011 <at> debbugs.gnu.org:


Received: (at 48011) by debbugs.gnu.org; 25 Apr 2021 08:58:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 25 04:58:44 2021
Received: from localhost ([127.0.0.1]:41984 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1laabE-0001uS-1w
	for submit <at> debbugs.gnu.org; Sun, 25 Apr 2021 04:58:44 -0400
Received: from eggs.gnu.org ([209.51.188.92]:34614)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1laabC-0001uE-4o
 for 48011 <at> debbugs.gnu.org; Sun, 25 Apr 2021 04:58:42 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34440)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1laab6-0002MP-01; Sun, 25 Apr 2021 04:58:36 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2868
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1laab4-00029s-OU; Sun, 25 Apr 2021 04:58:35 -0400
Date: Sun, 25 Apr 2021 11:58:13 +0300
Message-Id: <83v98alp0a.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Dan =?utf-8?B?xIxlcm3DoWs=?= <dan.cermak@HIDDEN>
In-Reply-To: <877dkqdclu.fsf@HIDDEN> (message from Dan
 =?utf-8?B?xIxlcm3DoWs=?= on Sun, 25 Apr 2021 09:53:17 +0200)
Subject: Re: bug#48011: 27.2; Emacs freezes in modula 2 mode when entering a :
References: <877dkqdclu.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48011
Cc: 48011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Dan Čermák <dan.cermak@HIDDEN>
> Date: Sun, 25 Apr 2021 09:53:17 +0200
> 
> This is a forward of https://bugzilla.redhat.com/show_bug.cgi?id=1950158
> 
> Emacs 27.2 freezes when editing a file that ends with .mod (i.e. it
> opens the file in Modula 2 mode) after one enters a ':'. The UI simply
> hangs until one interrupts it with C-g.
> 
> This happens with emacs -Q as well as with the Emacs flatpak (thus I
> assume that it is not Fedora specific).

I cannot reproduce this using the recipe in the Bugzilla report,
neither in Emacs 27.2 nor in the current master branch.  I see no
hang.

If C-g interrupts the hang, please set debug-on-signal non-nil, repeat
the recipe, press C-g, and post the Lisp backtrace here.

Thanks.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#48011; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Apr 2021 08:27:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 25 04:27:03 2021
Received: from localhost ([127.0.0.1]:41949 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1laa6X-00019z-Te
	for submit <at> debbugs.gnu.org; Sun, 25 Apr 2021 04:27:03 -0400
Received: from lists.gnu.org ([209.51.188.17]:46904)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dan.cermak@HIDDEN>) id 1laZaF-0000OL-H6
 for submit <at> debbugs.gnu.org; Sun, 25 Apr 2021 03:53:40 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:35576)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <dan.cermak@HIDDEN>)
 id 1laZaF-0001YJ-3B
 for bug-gnu-emacs@HIDDEN; Sun, 25 Apr 2021 03:53:39 -0400
Received: from cgc-instruments.com ([83.169.1.125]:57897)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <dan.cermak@HIDDEN>)
 id 1laZaB-00046i-Ob
 for bug-gnu-emacs@HIDDEN; Sun, 25 Apr 2021 03:53:38 -0400
Received: from localhost (ip4d17fc76.dynamic.kabel-deutschland.de
 [77.23.252.118])
 by cgc-instruments.com (Postfix) with ESMTPSA id D9CFBA10A5
 for <bug-gnu-emacs@HIDDEN>; Sun, 25 Apr 2021 09:53:29 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cgc-instruments.com;
 s=default; t=1619337210;
 bh=RTNWVBTN87RZ+3Dhc8QNvBM+ly+HuQPvd/bAI3R80XM=; l=14479;
 h=From:To:Subject;
 b=EnVlnkUKjVf/vuCTJdAXoGYtnRf2/DV8aTVLypvJaNFpyoA/VNs5nQVWtX6DNT9fw
 zWqLXIYjBDy0V0dLQ+jBpLi9gk6cbaSzoRfP66gt85AUfxgraKz7f4C4Dclhd2ojlk
 +yuKKQ/PGiZnpbp1/4ytJvSw8VFB2MWCKHB+ICik=
Authentication-Results: cgc-instruments.com;
 spf=pass (sender IP is 77.23.252.118)
 smtp.mailfrom=dan.cermak@HIDDEN smtp.helo=localhost
Received-SPF: pass (cgc-instruments.com: connection is authenticated)
From: Dan =?utf-8?B?xIxlcm3DoWs=?= <dan.cermak@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 27.2; Emacs freezes in modula 2 mode when entering a :
Date: Sun, 25 Apr 2021 09:53:17 +0200
Message-ID: <877dkqdclu.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
Received-SPF: pass client-ip=83.169.1.125;
 envelope-from=dan.cermak@HIDDEN; helo=cgc-instruments.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sun, 25 Apr 2021 04:27:00 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain

This is a forward of https://bugzilla.redhat.com/show_bug.cgi?id=1950158

Emacs 27.2 freezes when editing a file that ends with .mod (i.e. it
opens the file in Modula 2 mode) after one enters a ':'. The UI simply
hangs until one interrupts it with C-g.

This happens with emacs -Q as well as with the Emacs flatpak (thus I
assume that it is not Fedora specific).


Cheers,

Dan

In GNU Emacs 27.2 (build 1, x86_64-redhat-linux-gnu, GTK+ Version 3.24.27, cairo version 1.16.0)
 of 2021-03-27 built on buildvm-x86-31.iad2.fedoraproject.org
Windowing system distributor 'Fedora Project', version 11.0.12011000
System Description: Fedora 33 (Server Edition)

Recent messages:

Configured using:
 'configure --build=x86_64-redhat-linux-gnu
 --host=x86_64-redhat-linux-gnu --program-prefix=
 --disable-dependency-tracking --prefix=/usr --exec-prefix=/usr
 --bindir=/usr/bin --sbindir=/usr/sbin --sysconfdir=/etc
 --datadir=/usr/share --includedir=/usr/include --libdir=/usr/lib64
 --libexecdir=/usr/libexec --localstatedir=/var
 --sharedstatedir=/var/lib --mandir=/usr/share/man
 --infodir=/usr/share/info --with-dbus --with-gif --with-jpeg --with-png
 --with-rsvg --with-tiff --with-xft --with-xpm --with-x-toolkit=gtk3
 --with-gpm=no --with-xwidgets --with-modules --with-harfbuzz
 --with-cairo --with-json build_alias=x86_64-redhat-linux-gnu
 host_alias=x86_64-redhat-linux-gnu CC=gcc 'CFLAGS=-DMAIL_USE_LOCKF -O2
 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches
 -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2
 -Wp,-D_GLIBCXX_ASSERTIONS
 -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong
 -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic
 -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection'
 LDFLAGS=-Wl,-z,relro
 PKG_CONFIG_PATH=:/usr/lib64/pkgconfig:/usr/share/pkgconfig'

Configured features:
XPM JPEG TIFF GIF PNG RSVG CAIRO SOUND DBUS GSETTINGS GLIB NOTIFY
INOTIFY ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE HARFBUZZ M17N_FLT LIBOTF
ZLIB TOOLKIT_SCROLL_BARS GTK3 X11 XDBE XIM MODULES THREADS XWIDGETS
LIBSYSTEMD JSON PDUMPER GMP

Important settings:
  value of $LANG: en_US.utf8
  locale-coding-system: utf-8-unix

Major mode: notmuch-search

Minor modes in effect:
  git-identity-magit-mode: t
  magit-todos-mode: t
  global-git-commit-mode: t
  magit-auto-revert-mode: t
  recentf-mode: t
  tracking-mode: t
  telega-patrons-mode: t
  hl-line-mode: t
  which-key-mode: t
  zoom-mode: t
  editorconfig-mode: t
  engine-mode: t
  modern-c++-font-lock-global-mode: t
  global-diff-hl-mode: t
  global-display-line-numbers-mode: t
  display-line-numbers-mode: t
  show-smartparens-global-mode: t
  show-smartparens-mode: t
  smartparens-global-mode: t
  smartparens-mode: t
  show-paren-mode: t
  projectile-mode: t
  flycheck-color-mode-line-mode: t
  global-flycheck-mode: t
  flycheck-mode: t
  company-statistics-mode: t
  helm-mode: t
  shell-dirtrack-mode: t
  helm--remap-mouse-mode: t
  async-bytecomp-package-mode: t
  override-global-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  column-number-mode: 1
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
/home/dan/.emacs.d/elpa/cmake-mode-20210104.1831/cmake-mode hides /usr/share/emacs/site-lisp/cmake/cmake-mode
/home/dan/.emacs.d/elpa/clang-format-20191106.950/clang-format hides /usr/share/emacs/site-lisp/site-start.d/clang-format

Features:
(shadow yaml-imenu ansible-doc company-ansible company-ansible-keywords
yaml-mode tabify cal-move ledger-mode ledger-check ledger-texi
ledger-test ledger-sort ledger-report ledger-reconcile ledger-occur
ledger-fonts ledger-fontify ledger-state ledger-complete ledger-schedule
ledger-init ledger-xact ledger-post ledger-exec ledger-navigate
ledger-context ledger-commodities ledger-regex smartparens-c cc-mode
cc-fonts cc-guess cc-menus cc-cmds cc-styles cc-align cc-engine cc-vars
cc-defs rpm-spec-mode pulse magit-extras forge-list forge-commands
forge-semi forge-bitbucket buck forge-gogs gogs forge-gitea gtea
forge-gitlab glab forge-github ghub-graphql treepy gsexp ghub
forge-notify forge-revnote forge-pullreq forge-issue forge-topic
bug-reference forge-post forge-repo forge forge-core forge-db closql
emacsql-sqlite emacsql emacsql-compiler url-http url-auth url-gw
git-identity hydra magit-todos pcre2el rxt re-builder hl-todo
magit-bookmark magit-submodule magit-obsolete magit-blame magit-stash
magit-reflog magit-bisect magit-push magit-pull magit-fetch magit-clone
magit-remote magit-commit magit-sequence magit-notes magit-worktree
magit-tag magit-merge magit-branch magit-reset magit-files magit-refs
magit-status magit magit-repos magit-apply magit-wip magit-log
which-func magit-diff smerge-mode diff git-commit log-edit add-log
magit-core magit-autorevert magit-margin magit-transient magit-process
with-editor magit-mode transient magit-git magit-section magit-utils
lsp-diagnostics lsp-modeline lsp-headerline lsp-icons lsp-ui
lsp-ui-flycheck lsp-ui-doc xwidget lsp-ui-imenu lsp-ui-peek
lsp-ui-sideline lsp-ui-util vc-mtn vc-hg vc-bzr vc-src vc-sccs vc-svn
vc-cvs vc-rcs lsp-zig lsp-steep lsp-svelte lsp-sqls lsp-yaml lsp-xml
lsp-vimscript lsp-vhdl lsp-vetur lsp-html lsp-verilog lsp-vala
lsp-terraform lsp-tex lsp-sorbet lsp-solargraph lsp-rust lsp-rf lsp-r
lsp-purescript lsp-pyls lsp-pwsh lsp-php lsp-perl lsp-ocaml lsp-nix
lsp-nim lsp-lua lsp-kotlin lsp-json lsp-javascript lsp-haxe lsp-groovy
lsp-hack lsp-go lsp-completion lsp-gdscript lsp-fsharp lsp-fortran
lsp-eslint lsp-erlang lsp-elixir lsp-elm lsp-dockerfile lsp-dhall lsp-d
lsp-css lsp-csharp lsp-crystal lsp-cmake lsp-clojure lsp-clangd lsp-bash
lsp-angular lsp-ada lsp-actionscript lsp-mode lsp-protocol spinner
smartparens-markdown markdown-mode lv inline imenu f s
smartparens-python python sh-script smie executable qp sort gnus-alias
footnote mail-extr shr-color shr recentf tree-widget helm-x-files
helm-for-files helm-bookmark helm-adaptive bookmark pp windmove ripgrep
perl-mode rng-xsd xsd-regexp rng-cmpct rng-nxml rng-valid rng-loc
rng-uri rng-parse nxml-parse rng-match rng-dt rng-util rng-pttrn nxml-ns
nxml-mode nxml-outln nxml-rap smartparens-html sgml-mode nxml-util
nxml-enc xmltok conf-mode i3wm-config-mode editorconfig-core
editorconfig-core-handle editorconfig-fnmatch tramp-sh image-file
tramp-cache helm-external helm-net winner tramp-archive tramp-gvfs
zeroconf helm-command helm-elisp helm-eval edebug backtrace helm-info
misearch multi-isearch view emojify apropos tar-mode arc-mode
archive-mode ht mule-util gnutls network-stream nsm warnings slack
slack-company slack-unread slack-websocket slack-thread-event
slack-room-event slack-star-event slack-reaction-event slack-reply-event
slack-typing slack-slash-commands slack-message-event slack-event
slack-dialog-edit-element-buffer slack-dialog-buffer slack-dialog
slack-stars-buffer slack-search-result-buffer
slack-thread-message-compose-buffer slack-file-list-buffer
slack-file-info-buffer slack-all-threads-buffer slack-message-buffer
slack-user-profile-buffer slack-pinned-items-buffer slack-pinned-item
slack-thread-message-buffer slack-room-info-buffer slack-room-buffer
slack-message-share-buffer slack-message-edit-buffer
slack-room-message-compose-buffer slack-message-compose-buffer
slack-message-attachment-preview-buffer slack-action slack-star
slack-reminder slack-search slack-message-reaction slack-message-editor
slack-message-sender slack-message-notification alert log4e gntp
slack-buffer slack-message-formatter slack-thread slack-im slack-channel
slack-group slack-conversations slack-create-message slack-attachment
slack-selectable slack-bot-message slack-user-message slack-file
slack-message slack-message-faces slack-unescape slack-block
slack-mrkdwn slack-usergroup slack-reaction slack-modeline slack-room
slack-counts slack-user slack-bot slack-dnd-status slack-emoji
slack-image slack-request slack-log request lui tracking shorten
slack-team slack-team-ws slack-util websocket telega-obsolete telega
telega-tdlib-events telega-webpage visual-fill-column telega-root
telega-info telega-chat telega-modes image-mode exif telega-company
telega-user telega-notifications notifications dbus telega-voip
telega-msg telega-tme telega-sticker telega-i18n telega-vvnote bindat
telega-ffplay telega-media telega-sort telega-filter telega-ins
telega-folders telega-inline telega-tdlib telega-util
rainbow-identifiers org-agenda org-refile smartparens-org org ob
ob-tangle ob-ref ob-lob ob-table ob-exp org-macro org-footnote org-src
ob-comint org-pcomplete org-list org-faces org-entities noutline outline
org-version ob-emacs-lisp ob-core ob-eval org-table ol org-keys
org-compat org-macs org-loaddefs svg dom telega-server telega-core
cursor-sensor telega-customize emacsbug sendmail server notmuch hl-line
notmuch-tree notmuch-jump notmuch-hello notmuch-show notmuch-print
notmuch-crypto notmuch-mua notmuch-message notmuch-draft
notmuch-maildir-fcc notmuch-address notmuch-company notmuch-parser
notmuch-wash coolj notmuch-query goto-addr icalendar diary-lib
diary-loaddefs cal-menu calendar cal-loaddefs notmuch-tag crm
notmuch-lib notmuch-version notmuch-compat message rmc puny rfc822 mml
mailabbrev gmm-utils mailheader mm-view mml-smime mml-sec epa derived
epg epg-config gnus-util rmail rmail-loaddefs mail-utils
text-property-search smime dig mm-decode mm-bodies mm-encode mail-parse
rfc2231 rfc2047 rfc2045 mm-util ietf-drums mail-prsvr company-oddmuse
company-keywords company-etags company-gtags company-dabbrev-code
company-dabbrev company-files company-clang company-capf company-cmake
company-semantic company-template company-bbdb flyspell ispell
highlight-indent-guides heaven-and-hell which-key init zoom
shell-command+ eshell esh-cmd esh-ext esh-opt esh-proc esh-io esh-arg
esh-module esh-groups esh-util wgrep flycheck-ledger editorconfig crux
rfc-mode company-graphviz-dot graphviz-dot-mode avy company-web
company-css web-completion-data powerline powerline-separators
powerline-themes cap-words superword subword engine-mode go-projectile
autorevert vc-git go-rename go-guru go-eldoc go-mode url url-proxy
url-privacy url-expand url-methods url-history url-cookie url-domsuf
mailcap find-file ffap etags fileloop generator xref project
modern-cpp-font-lock git-link url-util dired dired-loaddefs diff-hl
log-view pcvs-util vc-dir ewoc vc vc-dispatcher diff-mode
display-line-numbers smartparens-config smartparens-text smartparens
paren yasnippet-snippets yasnippet projectile grep compile ibuf-ext
ibuffer ibuffer-loaddefs thingatpt flycheck-color-mode-line face-remap
flycheck find-func dash company-statistics company pcase cus-edit
cus-start cus-load wid-edit helm-mode helm-files filenotify tramp
tramp-loaddefs trampver tramp-integration files-x tramp-compat shell
pcomplete comint ansi-color ring parse-time iso8601 time-date ls-lisp
helm-buffers helm-occur helm-tags helm-locate helm-grep helm-regexp
format-spec helm-utils helm-help helm-types helm async-bytecomp advice
helm-global-bindings helm-easymenu helm-source helm-multi-match helm-lib
async helm-config solarized-theme auth-source-pass
solarized-light-high-contrast-theme solarized-palettes solarized
solarized-faces color diminish cl-extra help-mode use-package
use-package-ensure use-package-delight use-package-diminish
use-package-bind-key bind-key easy-mmode use-package-core finder-inf
erlang-start clang-rename clang-include-fixer let-alist clang-format xml
tex-site rx edmacro kmacro info package easymenu browse-url url-handlers
url-parse auth-source cl-seq eieio eieio-core cl-macs eieio-loaddefs
password-cache json subr-x map url-vars seq byte-opt gv bytecomp
byte-compile cconv cl-loaddefs cl-lib tooltip eldoc electric uniquify
ediff-hook vc-hooks lisp-float-type mwheel term/x-win x-win
term/common-win x-dnd tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode elisp-mode lisp-mode
prog-mode register page tab-bar menu-bar rfn-eshadow isearch timer
select scroll-bar mouse jit-lock font-lock syntax facemenu font-core
term/tty-colors frame minibuffer cl-generic cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms
cp51932 hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese composite charscript charprop case-table epa-hook
jka-cmpr-hook help simple abbrev obarray cl-preloaded nadvice loaddefs
button faces cus-face macroexp files text-properties overlay sha1 md5
base64 format env code-pages mule custom widget hashtable-print-readable
backquote threads dbusbind inotify dynamic-setting system-font-setting
font-render-setting xwidget-internal cairo move-toolbar gtk x-toolkit x
multi-tty make-network-process emacs)

Memory information:
((conses 16 1682829 568564)
 (symbols 48 67764 41)
 (strings 32 388434 107969)
 (string-bytes 1 12714393)
 (vectors 16 225420)
 (vector-slots 8 11251247 742094)
 (floats 8 7272 2983)
 (intervals 56 39684 17198)
 (buffers 1000 149))

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJTBAEBCAA9FiEE/2KDnDCX6+IOiSay5jLDOAYQ0cUFAmCFH+0fHGRhbi5jZXJt
YWtAY2djLWluc3RydW1lbnRzLmNvbQAKCRDmMsM4BhDRxZZMEAC66lYSVlT2lAVP
ZzQk3+01VwJ770b21Zu06dzy3vR4Ff/27usbVKBAwuEjCFxfUZ6kpSoqDNG9ZSkK
dCfXMu28WKBBBchGA08QQ96uPk/GgtSA0wwV1mR80pOv2URtNrQWyzlMNqqq3uxV
X7JN+cgeSE+AXW/l/AIQjeHkxAJZbKK9jK8x5MwjxCx4j+BiOypeCDndE6e9s5hH
RmkuqkNBt7fVYxV0bxYBZhnxpyD9LajgzGXW+zZKS906YDNQfUHilCiFp45BVDcl
KIf3aeQuAYLwn3diS09Mwb3AYllAMPZE3MDnGhePwvA5fG7fNTizF5iqsZkJh6EJ
lBq3e30ITD81pERNNa6uFNXdcF2/G7fw4ZTawju1CEhrCvexxSQqUuWroUd9GFQN
n9YEYt2sZtMhQebBFaBhHZE4znP8ZhJWbK/iHpLG70PRbKDWjlmy4ou/R54mlGKp
gFGlQkKE9gQ8od4WAD+1NeV1CihIJ/ypuG4rI4E+ph6+WPbpcJ0+9nNx8qAcSqEa
OvN8etX609cEovdbyOYDyqxarLO0zKJEilQuKVWeeqXPe5BkJe/5F2OsIuJRIjs/
h6l9Bu5y5XffDGfKFHDfh6LSYiPUzq3EfSpKNUntocFOcWxbFjf42UGK+AFDzhys
ZkraqlTpFyksmFPO5Hkkm29lX3Krjw==
=iJXr
-----END PGP SIGNATURE-----
--=-=-=--




Acknowledgement sent to Dan Čermák <dan.cermak@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#48011; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 27 Apr 2021 14:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.